; ##############################################################################
; ##############################################################################
; ##############################################################################
; BEGRUNG																		
ANZEIGE_BEGRUESSUNG:
	; ZEILE1	
	rcall LCD_CLEAR
	ldi ZH, high(TEXT_BEGRUESSUNG_1*2)	; TEXT 
	ldi ZL,  low(TEXT_BEGRUESSUNG_1*2)
	rcall ANZEIGE_TEXT
	; ZEILE2	
	rcall LCD_ZEILE2
	ldi ZH, high(TEXT_BEGRUESSUNG_2*2)	; TEXT 
	ldi ZL,  low(TEXT_BEGRUESSUNG_2*2)
	rcall ANZEIGE_TEXT
	; ZEILE3		
	rcall LCD_ZEILE3
	ldi ZH, high(TEXT_BEGRUESSUNG_3*2)	; TEXT 
	ldi ZL,  low(TEXT_BEGRUESSUNG_3*2)
	rcall ANZEIGE_TEXT
	; ZEILE4		
	rcall LCD_ZEILE4
	ldi ZH, high(TEXT_BEGRUESSUNG_4*2)	; TEXT 
	ldi ZL,  low(TEXT_BEGRUESSUNG_4*2)
	rcall ANZEIGE_TEXT
	rcall wait_100ms
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_ERROR:
	LDS temp,(adr_ERROR_CODE)
	tst temp	
	brne ANZEIGE_ERROR_RUN
	ret
;-------------------------------------------------------------------------------
ANZEIGE_ERROR_RUN:
	sbi (LED_GRUEN_PORT),(LED_GRUEN_PIN_NR)	; GRN aus	
	cbi (LED_ROT_PORT),(LED_ROT_PIN_NR)		; ROT  an	
	; ZEILE1
	rcall LCD_CLEAR
	rcall LCD_E
	rcall LCD_R
	rcall LCD_R
	rcall LCD_O
	rcall LCD_R
	rcall LCD_SPACE
	LDS temp1,(adr_ERROR_CODE)
	rcall ANZEIGE_HEX_TEMP1
;-------------------------------------------------------------------------------
	; ZEILE2
	rcall LCD_ZEILE2
	LDS temp,(adr_ERROR_CODE)
	STS(adr_ERROR_CODE),NULL	; NULL
;-------------------------------------------------------------------------------
	cpi temp,(ERROR_OW_SEARCH_AB)
	brne ANZEIGE_ERROR_NO_AB
	rcall LCD_S
	rcall LCD_E
	rcall LCD_A
	rcall LCD_R
	rcall LCD_C
	rcall LCD_H
	rcall LCD_MINUS
	rcall LCD_A
	rcall LCD_B
	ret
ANZEIGE_ERROR_NO_AB:
;-------------------------------------------------------------------------------
	cpi temp,(ERROR_OW_SEARCH_CRC)
	brne ANZEIGE_ERROR_NO_SEARCH_CRC
	rcall LCD_S
	rcall LCD_E
	rcall LCD_A
	rcall LCD_R
	rcall LCD_C
	rcall LCD_H
	rcall LCD_MINUS
	rcall LCD_C
	rcall LCD_R
	rcall LCD_C
	ret
ANZEIGE_ERROR_NO_SEARCH_CRC:
;-------------------------------------------------------------------------------
	cpi temp,(ERROR_OW_SEARCH_ANZAHL)
	brne ANZEIGE_ERROR_NO_SEARCH_ANZAHL
	rcall LCD_S
	rcall LCD_E
	rcall LCD_A
	rcall LCD_R
	rcall LCD_C
	rcall LCD_H
	rcall LCD_MINUS
	rcall LCD_A
	rcall LCD_N
	rcall LCD_Z
	rcall LCD_A
	rcall LCD_H
	rcall LCD_L
	ret
ANZEIGE_ERROR_NO_SEARCH_ANZAHL:
;-------------------------------------------------------------------------------
	cpi temp,(ERROR_OW_CRC)
	brne ANZEIGE_ERROR_NO_CRC
	rcall LCD_R
	rcall LCD_O
	rcall LCD_M
	rcall LCD_MINUS
	rcall LCD_C
	rcall LCD_R
	rcall LCD_C
	; ZEILE3
	rcall LCD_ZEILE3
	rcall ANZEIGE_ROM_ID_KURZ
	ret
ANZEIGE_ERROR_NO_CRC:
;-------------------------------------------------------------------------------
	cpi temp,(ERROR_OW_RESET_PRESENCE)
	brne ANZEIGE_ERROR_NO_RP
	rcall LCD_R
	rcall LCD_MINUS
	rcall LCD_P
	rcall LCD_R
	rcall LCD_E
	rcall LCD_S
	rcall LCD_E
	rcall LCD_N
	rcall LCD_C
	rcall LCD_E
	ret
ANZEIGE_ERROR_NO_RP:
;-------------------------------------------------------------------------------
	cpi temp,(ERROR_OW_BUS)
	brne ANZEIGE_ERROR_NO_BUS
	rcall LCD_B
	rcall LCD_U
	rcall LCD_S
	ret
ANZEIGE_ERROR_NO_BUS:
;-------------------------------------------------------------------------------
	cpi temp,(ERROR_TEMPERATURBERECHNUNG )
	brne ANZEIGE_ERROR_NO_x99
	ret
ANZEIGE_ERROR_NO_x99:
;-------------------------------------------------------------------------------
	cpi temp,(ERROR_OW_SCRATCHPAD_CRC)
	brne ANZEIGE_ERROR_NO_SCRC
	rcall LCD_S
	rcall LCD_C
	rcall LCD_R
	rcall LCD_MINUS
	rcall LCD_C
	rcall LCD_R
	rcall LCD_C
	; ZEILE3
	rcall LCD_ZEILE3
	rcall LCD_0
	rcall LCD_X_
	LDS temp1,(adr_SCRATCHPAD10+8)
	rcall ANZEIGE_HEX_TEMP1
	LDS temp1,(adr_SCRATCHPAD10+7)
	rcall ANZEIGE_HEX_TEMP1
	LDS temp1,(adr_SCRATCHPAD10+6)
	rcall ANZEIGE_HEX_TEMP1
	LDS temp1,(adr_SCRATCHPAD10+5)
	rcall ANZEIGE_HEX_TEMP1
	LDS temp1,(adr_SCRATCHPAD10+4)
	rcall ANZEIGE_HEX_TEMP1
	LDS temp1,(adr_SCRATCHPAD10+3)
	rcall ANZEIGE_HEX_TEMP1
	LDS temp1,(adr_SCRATCHPAD10+2)
	rcall ANZEIGE_HEX_TEMP1
	; ZEILE4
	rcall LCD_ZEILE4
	LDS temp1,(adr_SCRATCHPAD10+1)
	rcall ANZEIGE_HEX_TEMP1
	LDS temp1,(adr_SCRATCHPAD10+0)
	rcall ANZEIGE_HEX_TEMP1
	ret
ANZEIGE_ERROR_NO_SCRC:
;-------------------------------------------------------------------------------
; unbekannt																		
	rcall LCD_FRAGEZEICHEN
	rcall LCD_FRAGEZEICHEN
	rcall LCD_FRAGEZEICHEN
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_TESTWERT:
	; ZEILE1	
	rcall LCD_CLEAR
	ldi temp1,255
	ldi temp2,255
	ldi temp3,255
	ldi temp4,255
	rcall FUNKTION_HEX_ASC_32	; INPUT: temp1...4 OUTPUT: Temp1...9 (temp)		
	rcall LCD_AUSGABE_ZAHL_10_STELLEN_KURZ
	; ZEILE2	
	rcall LCD_ZEILE2
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################




