; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_TEXT_FAMILY_KURZ_TEMP1:
	cpi temp1,0x10	; DS18S20 (roter Farbpunkt)
	brne ANZEIGE_TEXT_NO_0x10
	rcall LCD_D
	rcall LCD_S
	rcall LCD_1
	rcall LCD_8
	rcall LCD_S
	rcall LCD_2
	rcall LCD_0
	
	rcall LCD_SPACE

	rcall LCD_R
	rcall LCD_0
	rcall LCD_T
	ret
ANZEIGE_TEXT_NO_0x10:
;---------------------------------------------------------------------------
	cpi temp1,0x22	; DS1822 (brauner Farbpunkt)
	brne ANZEIGE_TEXT_NO_0x22
	rcall LCD_D
	rcall LCD_S
	rcall LCD_1
	rcall LCD_8
	rcall LCD_2
	rcall LCD_2
	
	rcall LCD_SPACE

	rcall LCD_B
	rcall LCD_R
	rcall LCD_A
	rcall LCD_U
	rcall LCD_N
	ret
ANZEIGE_TEXT_NO_0x22:
;---------------------------------------------------------------------------
	cpi temp1,0x28	; DS18B20 (grner Farbpunkt)
	brne ANZEIGE_TEXT_NO_0x28
	rcall LCD_D
	rcall LCD_S
	rcall LCD_1
	rcall LCD_8
	rcall LCD_B
	rcall LCD_2
	rcall LCD_0
	
	rcall LCD_SPACE

	rcall LCD_G
	rcall LCD_R
	rcall LCD_U
	rcall LCD_E
	rcall LCD_N
	ret
ANZEIGE_TEXT_NO_0x28:
;---------------------------------------------------------------------------
	cpi temp1,0xEF
	brne ANZEIGE_TEXT_NO_0xEF
	rcall LCD_P
	rcall LCD_R
	rcall LCD_I
	rcall LCD_V
	rcall LCD_A
	rcall LCD_T
	ret
ANZEIGE_TEXT_NO_0xEF:
;---------------------------------------------------------------------------
	rcall ANZEIGE_HEX_TEMP1
	ldi temp, 'h'		; 
	rcall LCD_DATA
	rcall LCD_SPACE
	rcall LCD_F
	rcall LCD_A
	rcall LCD_M
	rcall LCD_SPACE
	rcall LCD_FRAGEZEICHEN
	rcall LCD_FRAGEZEICHEN
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_TEMPERATUR_KURZ:
	LDS temp1,(adr_TEMPERATUR_L)
	LDS temp2,(adr_TEMPERATUR_H)
	
	;ldi temp1,LOW (12)
	;ldi temp2,HIGH(12)

	tst temp2
	brpl ANZEIGE_TEMPERATUR_KURZ_POSITIV
;-------------------------------------------------------------------------------
ANZEIGE_TEMPERATUR_KURZ_NEGATIV:
	rcall LCD_MINUS
	com temp1
	com temp2
	add temp1,EINS
	adc temp2,NULL
	rjmp ANZEIGE_TEMPERATUR_KURZ_ACTION
;-------------------------------------------------------------------------------
ANZEIGE_TEMPERATUR_KURZ_POSITIV:
	rcall LCD_SPACE
;-------------------------------------------------------------------------------
; NULLSTELLENUNTERDRCKUNG														
ANZEIGE_TEMPERATUR_KURZ_ACTION:
	clr temp3
	clr temp4
	rcall FUNKTION_HEX_ASC_32	; INPUT: temp1...4 OUTPUT: Temp1...9 (temp)		
	cpi temp4,'0'
	brne ANZEIGE_TEMPERATUR_KURZ_RUN
	ldi temp4,' '
	cpi temp3,'0'
	brne ANZEIGE_TEMPERATUR_KURZ_RUN
	ldi temp3,' '
;-------------------------------------------------------------------------------
ANZEIGE_TEMPERATUR_KURZ_RUN:
	mov temp, temp4		; 
	rcall LCD_DATA
	mov temp, temp3		; 
	rcall LCD_DATA
	mov temp, temp2		; 
	rcall LCD_DATA
	ldi temp, ','		; 
	rcall LCD_DATA
	mov temp, temp1		; 
	rcall LCD_DATA
	ldi temp, ' '		; 
	rcall LCD_DATA
	ldi temp, 'C'		; 
	rcall LCD_DATA

ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_ROM_ID_KURZ:
	LDS temp1,(adr_ROM_CRC_BEREICH8+0)	; FAM	
	rcall ANZEIGE_HEX_TEMP1
	LDS temp1,(adr_ROM_CRC_BEREICH8+1)
	rcall ANZEIGE_HEX_TEMP1
	LDS temp1,(adr_ROM_CRC_BEREICH8+2)
	rcall ANZEIGE_HEX_TEMP1
	LDS temp1,(adr_ROM_CRC_BEREICH8+3)
	rcall ANZEIGE_HEX_TEMP1
	LDS temp1,(adr_ROM_CRC_BEREICH8+4)
	rcall ANZEIGE_HEX_TEMP1
	LDS temp1,(adr_ROM_CRC_BEREICH8+5)
	rcall ANZEIGE_HEX_TEMP1
	LDS temp1,(adr_ROM_CRC_BEREICH8+6)
	rcall ANZEIGE_HEX_TEMP1
	LDS temp1,(adr_ROM_CRC_BEREICH8+7)	; CRC	
	rcall ANZEIGE_HEX_TEMP1
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_SCRATCHPAD_KURZ9:
	; ZEILE2	
	rcall LCD_ZEILE2
	rcall LCD_0
	rcall LCD_X_
	LDS temp1,(adr_SCRATCHPAD10+8)
	rcall ANZEIGE_HEX_TEMP1
	LDS temp1,(adr_SCRATCHPAD10+7)
	rcall ANZEIGE_HEX_TEMP1
	LDS temp1,(adr_SCRATCHPAD10+6)
	rcall ANZEIGE_HEX_TEMP1
	LDS temp1,(adr_SCRATCHPAD10+5)
	rcall ANZEIGE_HEX_TEMP1
	; ZEILE3
	rcall LCD_ZEILE3
	LDS temp1,(adr_SCRATCHPAD10+4)
	rcall ANZEIGE_HEX_TEMP1
	LDS temp1,(adr_SCRATCHPAD10+3)
	rcall ANZEIGE_HEX_TEMP1
	LDS temp1,(adr_SCRATCHPAD10+2)
	rcall ANZEIGE_HEX_TEMP1
	LDS temp1,(adr_SCRATCHPAD10+1)
	rcall ANZEIGE_HEX_TEMP1
	LDS temp1,(adr_SCRATCHPAD10+0)
	rcall ANZEIGE_HEX_TEMP1
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_TEXT_RESET_KURZ:
	rcall LCD_CLEAR
	rcall LCD_R
	rcall LCD_E
	rcall LCD_S
	rcall LCD_E
	rcall LCD_T
	rjmp LCD_PUNKT3
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_TEXT_SEARCH_KURZ:
	rcall LCD_CLEAR
	rcall LCD_S
	rcall LCD_E
	rcall LCD_A
	rcall LCD_R
	rcall LCD_C
	rcall LCD_H
	rjmp LCD_PUNKT3
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_TEXT_MESSEN_KURZ:
	rcall LCD_CLEAR
	rcall LCD_M
	rcall LCD_E
	rcall LCD_S
	rcall LCD_S
	rcall LCD_E
	rjmp  LCD_N
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_TEXT_BUS_ERROR_KURZ:
	rcall LCD_CLEAR
	rcall LCD_B
	rcall LCD_U
	rcall LCD_S
	rcall LCD_SPACE
	rcall LCD_E
	rcall LCD_R
	rcall LCD_R
	rcall LCD_O
	rjmp LCD_R
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_TAKT_KURZ:
	ldi temp1,BYTE1(TAKT)
	ldi temp2,BYTE2(TAKT)
	ldi temp3,BYTE3(TAKT)
	ldi temp4,BYTE4(TAKT)
	rcall FUNKTION_HEX_ASC_32	; INPUT: temp1...4 OUTPUT: Temp1...9 (temp)		
	rcall LCD_FORMAT
	rcall LCD_AUSGABE_ZAHL_9_STELLEN_KURZ
	rcall LCD_SPACE
	ldi temp,'M'
	rcall LCD_DATA
	ldi temp,'H'
	rcall LCD_DATA
	ldi temp,'z'
	rcall LCD_DATA
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_SRAM_END_KURZ:
	ldi temp1,BYTE1(RAMEND)
	ldi temp2,BYTE2(RAMEND)
	ldi temp3,BYTE3(RAMEND)
	ldi temp4,BYTE4(RAMEND)
	rcall FUNKTION_HEX_ASC_32	; INPUT: temp1...4 OUTPUT: Temp1...9 (temp)		
	rcall LCD_FORMAT
	rcall LCD_AUSGABE_ZAHL_9_STELLEN_KURZ
	rcall LCD_SPACE
	ldi temp,'S'
	rcall LCD_DATA
	ldi temp,'R'
	rcall LCD_DATA
	ldi temp,'A'
	rcall LCD_DATA
	ldi temp,'M'
	rcall LCD_DATA
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
